// Copyright (C) 2009 Shawn W. Walker.
// Licensed under the GNU LGPL Version 2.1.
//
// Modified by Shawn W. Walker, 2009.
//
// This demo reads in a 2-D mesh with higher order vertex data.
// Data pertaining to the mesh is displayed.

#include <dolfin.h>

using namespace dolfin;

int main()
{
  // Load reference mesh (just two triangles)
  Mesh mesh_t;
  File file_t("P2_Mesh_Ex.xml", true);
  file_t >> mesh_t;

  bool *Affine_Cell;
  Affine_Cell = mesh_t.geometry().affine_cell_bool();
  if (Affine_Cell[0])
    { cout << "Cell 0 is affine." << endl; }  
  else
    { cout << "Cell 0 is NOT affine." << endl; }
  if (Affine_Cell[1])
    { cout << "Cell 1 is affine." << endl; }
  else
    { cout << "Cell 1 is NOT affine." << endl; }
    
  cout << "-----------------" << endl;  
  
  double *HO_Coordinates;
  HO_Coordinates = mesh_t.geometry().higher_order_x();
  cout << "Higher Order Vertex 0 is: " << "(" << HO_Coordinates[0*2 + 0] << "," << HO_Coordinates[0*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 1 is: " << "(" << HO_Coordinates[1*2 + 0] << "," << HO_Coordinates[1*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 2 is: " << "(" << HO_Coordinates[2*2 + 0] << "," << HO_Coordinates[2*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 3 is: " << "(" << HO_Coordinates[3*2 + 0] << "," << HO_Coordinates[3*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 4 is: " << "(" << HO_Coordinates[4*2 + 0] << "," << HO_Coordinates[4*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 5 is: " << "(" << HO_Coordinates[5*2 + 0] << "," << HO_Coordinates[5*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 6 is: " << "(" << HO_Coordinates[6*2 + 0] << "," << HO_Coordinates[6*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 7 is: " << "(" << HO_Coordinates[7*2 + 0] << "," << HO_Coordinates[7*2 + 1] << ")" << endl;
  cout << "Higher Order Vertex 8 is: " << "(" << HO_Coordinates[8*2 + 0] << "," << HO_Coordinates[8*2 + 1] << ")" << endl;

  cout << "-----------------" << endl;
  
  dolfin::uint *HO_CellData;
  HO_CellData = mesh_t.geometry().higher_order_cells();
  cout << "Higher Order Cell #0 is: " << "[" << HO_CellData[0*6 + 0] << ", " << HO_CellData[0*6 + 1] << ", "
       << HO_CellData[0*6 + 2] << ", " << HO_CellData[0*6 + 3] << ", " << HO_CellData[0*6 + 4] << ", "
       << HO_CellData[0*6 + 5] << "]" << endl;
  cout << "Higher Order Cell #1 is: " << "[" << HO_CellData[1*6 + 0] << ", " << HO_CellData[1*6 + 1] << ", "
       << HO_CellData[1*6 + 2] << ", " << HO_CellData[1*6 + 3] << ", " << HO_CellData[1*6 + 4] << ", "
       << HO_CellData[1*6 + 5] << "]" << endl;

  return 0;
}
